#!/usr/bin/env python
# Copyright (c) 2014, The MITRE Corporation. All rights reserved.
# See LICENSE.txt for complete terms.

import sys
from stix.core import STIXPackage


def parse_stix(pkg):
    print("== MALWARE ==")
    for fam in pkg.ttps:
        print("---")
        print("Title : " + fam.title)
        print("ID : " + fam.id_)
        for sample in fam.behavior.malware_instances:
            print("Sample: " + str(sample.names[0]))
            print("Type: " + str(sample.types[0]))

    for ind in pkg.indicators:
        print("---")
        print("Title : " + ind.title)
        print("Type : " + str(ind.indicator_types[0]))
        print("ID -> : " + ind.indicated_ttps[0].item.idref)

        for obs in ind.observables:
            for digest in obs.object_.properties.hashes:
                print("Hash : " + str(digest))

    return 0

if __name__ == '__main__':
    try:
        fname = sys.argv[1]
    except:
        exit(1)
    fd = open(fname)
    stix_pkg = STIXPackage.from_xml(fd)

    parse_stix(stix_pkg)
